/* Bessel Functions of Integer Order */

/*
Sample page from NUMERICAL RECIPES IN C: THE ART OF SCIENTIFIC COMPUTING (ISBN 0-521-43108-5)
Copyright (C) 1988-1992 by Cambridge University Press.
Programs Copyright (C) 1988-1992 by Numerical Recipes Software. 
Permission is granted for internet users to make one paper copy for their own personal use. 
Further reproduction, or any copying of machine-readable files (including this one) to any server
computer, is strictly prohibited. To order Numerical Recipes books,
diskettes, or CDROMsvisit website http://www.nr.com or call 1-800-872-7423 (North America only),
or send email to trade@cup.cam.ac.uk (outside North America). 
*/

#ifdef __cplusplus
extern "C" {
#endif

float bessj0 ( float x );  /** Returns the Bessel function J0(x) for any real x */
float bessy0 ( float x );  /** Returns the Bessel function Y0(x) for positive x */
float bessj1 ( float x );  /** Returns the Bessel function J1(x) for any real x */
float bessy1 ( float x );  /** Returns the Bessel function Y1(x) for positive x */

float bessy ( int n, float x );  /** Returns the Bessel function Yn(x) for positive x and n >= 2 */
float bessj ( int n, float x );  /** Returns the Bessel function Jn(x) for any real x and n >= 2 */

#ifdef __cplusplus
}
#endif
