/* -*- C++ -*- *************************************************************
 *
 *  parameter.cpp, Tue Mar 5 2002
 *  Copyright (C) 2002 Soloviev Alexei <solovjev@cv.jinr.ru>, Alexei Stadnik
 *
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "parameter.h"

Parameter::Parameter ( const string & name,
		       const double & value,
		       const double & error )
  : fName(name), fValue(value), fError(error), fMin(0), fMax(0)
{}

Parameter::Parameter ( const string & name,
		       const double & value,
		       const double & error,
		       const double & min,
		       const double & max )
  : fName(name), fValue(value), fError(error), fMin(min), fMax(max) 
{}

Parameter::~Parameter() {}

/** Get parameter description */
const std::string & Parameter::name() const
{
  return fName;
}

/** Access to parameter value (read) */
const double & Parameter::value() const 
{
  return fValue;
}

/** Access to parameter value (write) */
double & Parameter::value() 
{
  return fValue;
}

/** Access to parameter error (read) */
const double & Parameter::error() const 
{
  return fError;
}

/** Access to parameter error (write) */
double & Parameter::error() 
{
  return fError;
}

/** Access to parameter min value (read) */
const double & Parameter::min() const
{
  return fMin;
}

/** Access to parameter max value (read) */
const double & Parameter::max() const
{
  return fMax;
}
